// newguys.cpp : Implementation of Cnewguys
#include "stdafx.h"
#include "Asp1504.h"
#include "newguys.h"

#import "C:\Program Files\Common Files\System\ADO\msado15.dll" \
    no_namespace rename("EOF", "EndOfFile")

inline void TESTHR(HRESULT x) {if FAILED(x) _com_issue_error(x);};
/////////////////////////////////////////////////////////////////////////////
// Cnewguys
HRESULT Cnewguys::Activate()
{
   HRESULT hr = S_OK;
   CComVariant vt;
   CComPtr<IGetContextProperties> pProps; //Context Properties

   IDispatch* piDispatch = NULL;

   // get ObjectContext
   hr = CoGetObjectContext(IID_IObjectContext, (void **)&m_spObjectContext);
   if (FAILED(hr))
      return hr;
   
   // get Context Properties
   hr = m_spObjectContext->QueryInterface( IID_IGetContextProperties, 
               (void**)&pProps );
   if (FAILED(hr)) 
       return hr;

   // get Response property
   hr = pProps->GetProperty( _bstr_t("Response"), &vt ) ;

   if (FAILED(hr))
       return hr;

   piDispatch = vt. pdispVal;
   hr = piDispatch->QueryInterface( IID_IResponse, 
                     (void**)&m_piResponse );

   return hr;
} 

BOOL Cnewguys::CanBePooled()
{
	return TRUE;
} 

void Cnewguys::Deactivate()
{
    m_piResponse.Release();
	m_spObjectContext.Release();
} 


STDMETHODIMP Cnewguys::displayFileNames(BSTR bstrURL)
{
   _RecordsetPtr pRecs = NULL;  
   _RecordPtr pRec = NULL;


   try {
      // create objects
          TESTHR(pRec.CreateInstance(__uuidof(Record)));

      _bstr_t bURL = L"URL=" + _bstr_t(bstrURL);

      // open URL into record
      pRec->Open("",bURL,adModeUnknown,adFailIfNotExists,
           adOpenRecordUnspecified,"","");

      // get children (files, directories)
      pRecs = pRec->GetChildren();

      // display filenames
      _variant_t vtVal;
      vtVal.lVal = 0;
      vtVal.vt = VT_I4;
      while(!(pRecs->EndOfFile)) {
          m_piResponse->Write(pRecs->Fields->GetItem(vtVal)->GetValue());
          m_piResponse->Write(_variant_t("<br>"));
          pRecs->MoveNext();
      }

      // close record, recordset
      pRec->Close();
      pRecs->Close();

   }
   catch (_com_error e) {
     m_piResponse->Write(_variant_t(e.Description()));
   }

   return S_OK;
}

STDMETHODIMP Cnewguys::copyFile(BSTR bstrURL, BSTR bstrFile, BSTR bstrNewFile)
{
   _RecordPtr pRec = NULL;
   _StreamPtr pStream = NULL;

   try {

      // create objects
      TESTHR(pStream.CreateInstance(__uuidof(Stream)));
      TESTHR(pRec.CreateInstance(__uuidof(Record))) ;

      _bstr_t bURL = L"URL=" + _bstr_t(bstrURL);

      pRec->Open(bstrFile,bURL,adModeRead,
           (RecordCreateOptionsEnum)(adOpenIfExists | adCreateStructDoc),
           adOpenRecordUnspecified,"","");

      // open stream
      pStream->Open(pRec.GetInterfacePtr(),adModeRead,adOpenStreamFromRecord,"","");

      pStream->PutCharset(L"ascii");
      pStream->PutType(adTypeText);

      _bstr_t bstrText;
      bstrText = pStream->ReadText(adReadAll);

      // close objects for re-use
      pRec->Close();
      pStream->Close();

      // copy file
      pRec->Open(bstrNewFile,bURL,adModeWrite,
                  (RecordCreateOptionsEnum)(adCreateStructDoc | adCreateOverwrite),
                  adOpenRecordUnspecified,"","");

      pStream->Open(pRec.GetInterfacePtr(),adModeWrite,adOpenStreamFromRecord,"","");
      pStream->WriteText(bstrText,adWriteChar);

      // cleanup
      pRec->Close();
      pStream->Close();

}
   catch (_com_error e) {

     m_piResponse->Write(_variant_t(e.Description()));
   }

   return S_OK;
}
