// search.cpp : Implementation of Csearch
#include "stdafx.h"
#include "Asp1703.h"
#include "search.h"

/////////////////////////////////////////////////////////////////////////////
// Csearch


STDMETHODIMP Csearch::doQuery(BSTR bstrClass)
{
   HRESULT hr = S_OK;

   CComPtr<IObjectContext> spObjectContext;
   CComPtr<IResponse> piResponse;
   CComBSTR bstrObj;
   CComVariant vt;
   CComPtr<IGetContextProperties> pProps; //Context Properties

   IDispatch* piDispatch = NULL;

   // get ObjectContext
	hr = CoGetObjectContext(IID_IObjectContext, 
                                    (void **)&spObjectContext);
   if (FAILED(hr))
      return hr;
   
   // get Context Properties
   hr = spObjectContext->QueryInterface( IID_IGetContextProperties, 
               (void**)&pProps );
   if (FAILED(hr)) 
       return hr;

   // get Response property
   bstrObj = "Response";
   hr = pProps->GetProperty( bstrObj, &vt ) ;

   if (FAILED(hr))
       return hr;

   piDispatch = vt. pdispVal;
   hr = piDispatch->QueryInterface( IID_IResponse, 
                     (void**)&piResponse );

   // Active Directory code
   IDirectorySearch *pDSearch;

   // array with selection list items
   LPWSTR pszAttr[] = { L"cn", L"samAccountName", L"distinguishedName", L"ADsPath" };
   ADS_SEARCH_HANDLE hSearch;
   ADS_SEARCH_COLUMN hCol;
   DWORD dwCount= sizeof(pszAttr)/sizeof(LPWSTR);

   // create search string for given object class
   _bstr_t bstrCls = bstrClass;
   _bstr_t bstrSearch = "(objectClass=" + bstrCls + ")";
   _variant_t varout;
   int i;

   // get IDirectorySearch for domain
   hr = ADsGetObject(L"LDAP://DC=development,DC=local",
                     IID_IDirectorySearch,
                     (void **) &pDSearch);
   if (FAILED(hr))
       return hr;
   
   // execute search
   // pass in search string, selection list array, and search handle
   hr = pDSearch->ExecuteSearch((LPWSTR)bstrSearch,pszAttr,dwCount,&hSearch);

   if (FAILED(hr))
       return hr;

   // while more rows
   // print out selection list items
   // item name on left, value on right
   while(  pDSearch->GetNextRow(hSearch)  != S_ADS_NOMORE_ROWS ) {
      for (i = 0; i < 4; i++) {
         varout = pszAttr[i];
         piResponse->Write(varout);
         varout = " = ";
         piResponse->Write(varout);

         // set column to column handle
         pDSearch->GetColumn(hSearch,pszAttr[i],&hCol);
         varout = hCol.pADsValues->CaseIgnoreString;
         piResponse->Write(varout);
         varout="<br>";
         piResponse->Write(varout);

         // free column handle
         pDSearch->FreeColumn(&hCol);
      }
      varout="<p>";
      piResponse->Write(varout);
   }

   // cleanup
   pDSearch->CloseSearchHandle(hSearch); 
   pDSearch->Release();

   return hr;
}
