// msgqueue.cpp : Implementation of Cmsgqueue
#include "stdafx.h"
#include "Asp1802.h"
#include "msgqueue.h"

/////////////////////////////////////////////////////////////////////////////
// Cmsgqueue


STDMETHODIMP Cmsgqueue::findQueues(BSTR bstrLabel)
{

   HRESULT hr = S_OK;

   // **** create Response object **** //

   CComPtr<IObjectContext> spObjectContext;
   CComPtr<IResponse> piResponse;
   CComBSTR bstrObj;
   CComVariant vt;
   CComPtr<IGetContextProperties> pProps; //Context Properties

   IDispatch* piDispatch = NULL;

   // get ObjectContext
	hr = CoGetObjectContext(IID_IObjectContext, 
                                    (void **)&spObjectContext);
    if (FAILED(hr)) return hr;
   
   // get Context Properties
   hr = spObjectContext->QueryInterface( IID_IGetContextProperties, 
               (void**)&pProps );
   if (FAILED(hr)) return hr;

   // get Response property
   bstrObj = "Response";
   hr = pProps->GetProperty( bstrObj, &vt ) ;

   if (FAILED(hr)) return hr;

   piDispatch = vt. pdispVal;
   hr = piDispatch->QueryInterface( IID_IResponse, 
                     (void**)&piResponse );

   // ****  MSMQ functionality ***//

   // * First, search for queues based on label
   //   return path name  * //

   MQPROPERTYRESTRICTION PropertyRestriction;
   MQRESTRICTION  Restriction;
   MQCOLUMNSET    Column;
   PROPID    aPropId[2];     

   // set search string -- search based on label
   PropertyRestriction.rel = PREQ;
   PropertyRestriction.prop = PROPID_Q_LABEL;
   PropertyRestriction.prval.vt = VT_LPWSTR;
   PropertyRestriction.prval.pwszVal =(LPWSTR)bstrLabel;

   // Set restriction
   Restriction.cRes = 1;
   Restriction.paPropRes = &PropertyRestriction;

   // set column list -- pathname and label
   aPropId[0] = PROPID_Q_PATHNAME;

   Column.cCol = 1;
   Column.aCol = aPropId;

   // do query
   HANDLE         hEnum;
   hr=MQLocateBegin( NULL, &Restriction,   
                        &Column, NULL,&hEnum);
   if (FAILED(hr)) return hr;

   DWORD dwPrpCt = 1;
   MQPROPVARIANT aPropVar[1];

   hr = MQLocateNext(hEnum,&dwPrpCt,aPropVar);
   if (FAILED(hr)) return hr;

   // **** Process queue results **** //
   //     * until props are zero * //
   while (dwPrpCt > 0) {

      // get path
      _bstr_t bstrPath = aPropVar[0].bstrVal;

      // get formatted name
      DWORD dwFormatNameBufferLength = 256;               
      WCHAR wszFormatNameBuffer[256];                     

      // get format name
      hr= MQPathNameToFormatName((LPWSTR)bstrPath,
                              wszFormatNameBuffer,
                              &dwFormatNameBufferLength);

      if (FAILED(hr)) return hr;

      // use formatted name to find DNS path
      // using MQGetQueueProperties
      MQQUEUEPROPS qprops;
      PROPVARIANT aQueuePropVar[1];
      QUEUEPROPID aQueuePropId[1];
      HRESULT aQueueStatus[1];
  
      // set pathname dns property
      aQueuePropId[0] = PROPID_Q_PATHNAME_DNS;
      aQueuePropVar[0].vt = VT_NULL;

      qprops.aPropID = aQueuePropId;
      qprops.aPropVar = aQueuePropVar;
      qprops.aStatus = aQueueStatus;
      qprops.cProp = 1;

      // get dns pathname
      hr = MQGetQueueProperties(wszFormatNameBuffer, &qprops);
      if (FAILED(hr)) return hr;


      // get value of path
      _bstr_t bstrDnsPath = aQueuePropVar[0].bstrVal;

      // now, FINALLY, print out results
      piResponse->Write(_variant_t(wszFormatNameBuffer));
      piResponse->Write(_variant_t("<br>"));
      piResponse->Write(_variant_t(bstrDnsPath + "<br>"));
      piResponse->Write(_variant_t(bstrPath + "<p>"));

      MQLocateNext (hEnum, &dwPrpCt,aPropVar);
   }
 
   hr=MQLocateEnd(hEnum);
   
   return hr;
}
