// Advanced.h : Declaration of the CAdvanced

#ifndef __ADVANCED_H_
#define __ADVANCED_H_

#include "resource.h"       // main symbols
#include <mtx.h>
#include <asptlb.h>

#include "Game.h"
/////////////////////////////////////////////////////////////////////////////
// CAdvanced
class ATL_NO_VTABLE CAdvanced : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CAdvanced, &CLSID_Advanced>,
	public IObjectControl,
	public IDispatchImpl<IAdvanced, &IID_IAdvanced, &LIBID_ASP1901Lib>
{
public:
	CAdvanced()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_ADVANCED)

DECLARE_PROTECT_FINAL_CONSTRUCT()

DECLARE_NOT_AGGREGATABLE(CAdvanced)

BEGIN_COM_MAP(CAdvanced)
	COM_INTERFACE_ENTRY(IAdvanced)
	COM_INTERFACE_ENTRY(IObjectControl)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IObjectControl
public:
	STDMETHOD(Activate)();
	STDMETHOD_(BOOL, CanBePooled)();
	STDMETHOD_(void, Deactivate)();

	CComPtr<IObjectContext> m_spObjectContext;

// IAdvanced
public:
	STDMETHOD(getScore)(/*[out]*/ VARIANT* varScore, VARIANT* varTime, /*[out,retval]*/ BSTR* pbstrName);
	STDMETHOD(setScore)(/*[in]*/ BSTR bstrName, int iScore, int iTime );
	STDMETHOD(getInfo)(BSTR *pbstrName);
	STDMETHOD(setInfo)(BSTR bstrName);

private:
    CComPtr<IResponse> m_piResponse;
};

#endif //__ADVANCED_H_
