import com.ms.mtx.*;
import com.ms.com.*;
import com.ms.asp.IResponse;

/**
 * This class is designed to be packaged with a COM DLL output format.
 * The class has no standard entry points, other than the constructor.
 * Public methods will be exposed as methods on the default COM interface.
 * @com.register ( clsid=71BB31B6-9100-467B-B650-1C9E6CE9745E, typelib=85BE579C-5173-40C4-952C-E81303B3D163 )
 */
public class ObjCont
{

   public void showStatus(Variant vtSep)
   {
      
   IObjectContext objCont = null;
   IGetContextProperties objProps = null;
   IResponse objResponse = null;
   
   Variant v = new Variant();
   
   // get ObjectContext, Props, and Response
   objCont = MTx.GetObjectContext();
   objProps = (IGetContextProperties)MTx.GetObjectContext();
   
   // get response
   v = objProps.GetProperty("Response");
   objResponse = (IResponse)v.getDispatch();
   v.VariantClear();
   
   // print out state
   try {
      if (objCont.IsInTransaction())
         v.putString("In Transaction");
      else
         v.putString("Not in Transaction");
      objResponse.Write(v);
      objResponse.Write(vtSep);
      v.VariantClear();
      
      if (objCont.IsCallerInRole("Developer"))
         v.putString("In Role");
      else
         v.putString("Not in Role");
      objResponse.Write(v);
      objResponse.Write(vtSep);
      v.VariantClear();
      
      if (objCont.IsSecurityEnabled())
         v.putString("Security Enabled");
      else
         v.putString("Security not enabled");
      objResponse.Write(v);
      objResponse.Write(vtSep);
      v.VariantClear();
      }
   catch(Exception e) {
      v.putString(e.getLocalizedMessage());
      objResponse.Write(v);
      }
   }
}
