unit msg;

interface

uses
  ComObj, ActiveX, asp2104_TLB, ADODB_TLB, CDO_TLB, StdVcl;

type
  Tmsg = class(TAutoObject, Imsg)
  protected
    procedure sendImage(const bstrTo, bstrFrom, bstrSubject,
      bstrMessage, bstrImage: WideString); safecall;
    { Protected declarations }
  end;

implementation

uses ComServ;

procedure Tmsg.sendImage(const bstrTo, bstrFrom, bstrSubject,
  bstrMessage, bstrImage: WideString);
var
cdomsg: IMessage;
config: IConfiguration;
bodypart: IBodyPart;
strm: Stream;
begin
cdomsg := CoMessage.Create;
config := CoConfiguration.Create;

// set configuration
with config.Fields do
begin
Item['http://schemas.microsoft.com/cdo/configuration/sendusing'].Set_Value(cdoSendUsingPort);
Item['http://schemas.microsoft.com/cdo/configuration/smtpauthenticate'].Set_Value(cdoBasic);
Item['http://schemas.microsoft.com/cdo/configuration/smtpserver'].Set_Value('mail.someco.com');
Item['http://schemas.microsoft.com/cdo/configuration/smtpconnectiontimeout'].Set_Value(20);
end;
config.Fields.Update;

// set message properties
cdomsg.Set_Configuration(config);
cdomsg.Set_Sender(bstrFrom);
cdomsg.Set_To_(bstrTo);
cdomsg.Set_Subject(bstrSubject);

// add image attachment
bodypart := cdomsg.Get_BodyPart;
bodypart.Set_ContentMediaType('image/gif');
bodypart.Set_ContentTransferEncoding('base64');
strm := bodypart.GetDecodedContentStream;
strm.LoadFromFile(bstrImage);
strm.Flush;

// message to go with image
cdomsg.Set_TextBody(bstrMessage);

// send
cdomsg.Send;

end;

initialization
  TAutoObjectFactory.Create(ComServer, Tmsg, Class_msg,
    ciMultiInstance, tmBoth);
end.
