package aspado;

use Win32::OLE::Const ('Microsoft ActiveX Data Objects 2.5 Library');

# create object using anonymous hash
sub new {

    # Get the name of the class, always passed as first paren
    my $class = shift;

    # Get object reference
    my $self = {};

    # bless object and return
    return bless $self, ref($class) || $class;
}

# get authors last names and print
sub getWebPages { 
  
  # create Connection and Recordset objects
  $mtx = Win32::OLE->new("MTxAS.AppServer.1");
  $obj = $mtx->GetObjectContext();
  $server = $obj->Item('Server');

  # create connection and recordset objects
  $conn = $server->CreateObject("ADODB.Connection");
  $rs = $server->CreateObject("ADODB.Recordset");

  # open connection to database
  $conn->Open("provider=SQLOLEDB;server=FLAME;uid=sa;pwd=;database=weaver");        

  # set Recordset properties
  # two ways to set COM/COM+ object properties
  $rs->{ActiveConnection} = $conn;
  $rs->SetProperty('CursorLocation', adUseClient);  
  $rs->{CursorType} = adOpenForwardOnly;                  
  $rs->{Source} = "select name from WebPage";

  # open recordset
  $rs->Open();

  # filter and sort recordset
  $rs->{Sort} = "name asc";
  $rs->SetProperty('Filter',"name > 'ARTICLES'");

  # get recordcount
  $val = $rs->{RecordCount};

  # move through recordset and print out field value
  if ($val > 0) {
     $rs->MoveFirst;
      
     until ($rs->EOF) {
       $strResult = $strResult . $rs->Fields(0)->value . "<br>";
       $rs->MoveNext;
       }
  }

  # disconnect from database
  $conn->Close;
  return $strResult;
}

# get Web Page info
sub getHtmlWebPageInfo {
  local($self, $dirid) = @_;

  # create Connection and Recordset objects
  $mtx = Win32::OLE->new("MTxAS.AppServer.1");
  $obj = $mtx->GetObjectContext();
  $server = $obj->Item('Server');
  $response = $obj->Item('Response');

  # create connection and recordset objects
  $cmnd = $server->CreateObject("ADODB.Command");
  $conn = $server->CreateObject("ADODB.Connection");
  $rs = $server->CreateObject("ADODB.Recordset");

  # open connection to database
  $conn->Open("provider=SQLOLEDB;server=FLAME;uid=sa;pwd=;database=weaver");        

  $cmnd->{ActiveConnection} = $conn;
  $cmnd->{CommandType} = adCmdStoredProc;   
  $cmnd->{CommandText} = "sp_gethtmlwebpageinfo";

  $param = $cmnd->CreateParameter("type", adInteger,adParamInput);

  $cmnd->Parameters->Append($param);
  $cmnd->Parameters->Item(0)->{value} = $dirid;

  $rs = $cmnd->Execute;
  
  $val = $rs->{RecordCount};

  # move through recordset and print out field value
  $rs->MoveFirst;
  
  # values are printed out to an HTML table    
  $response->Write("<table width=95% align=center cellpadding=10 border=2>");
  $response->Write("<TR><TH align=left>Page Name</TH>");
  $response->Write("<TH align=left>File Name</TH><TH align=left>HTML Version</TH></TR>");
  until ($rs->EOF) {
    $name = $rs->Fields('name')->value;
    $filename = $rs->Fields('filename')->value;
    $html_version = $rs->Fields('html_version')->value;
   
    $response->Write("<TR>");
    $response->Write("<TD>$name</TD><TD>$filename</TD><TD>$html_version</TD>");
    $response->Write("</TR>");
    
    $rs->MoveNext;
    }
  $response->Write("</TABLE>");
  
  # close connection
  $conn->Close;
  }

1;