VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cmnd"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Sub showPages(ByVal varTypes As Variant)

Dim cmndObject As New Command
Dim parm As Parameter
Dim rs As Recordset

' set command properties
cmndObject.ActiveConnection = "Provider=SQLOLEDB;server=FLAME;" & _
                              "database=weaver;" & _
                              "uid=sa;pwd="
cmndObject.Prepared = True
cmndObject.CommandType = adCmdText
cmndObject.CommandText = "select name, filename from WebPage where " & _
                         "page_type_cd = ?"
                         
'set parameter
Set parm = cmndObject.CreateParameter("page_type_cd", adChar, adParamInput, 3)
cmndObject.Parameters.Append parm

' get array boundaries
Dim lLow, lHigh, l
Dim val As Variant
lLow = LBound(varTypes)
lHigh = UBound(varTypes)

' for each entry in array
' set parm value, and execute command
For l = lLow To lHigh

  ' get parameter
  val = varTypes(l)
  
  ' set parameter and execute
  parm.Value = val
  Set rs = cmndObject.Execute
  
  ' process results
  showPageInfo rs, val
Next

Set cmndObject = Nothing

End Sub

' display records
Private Sub showPageInfo(rs As Recordset, ByVal val)

Dim objContext As ObjectContext
Dim objResponse As Response

Set objContext = GetObjectContext()
Set objResponse = objContext("Response")

' process and display records
objResponse.Write "<h3>" & val & "</h3>"
objResponse.Write "<TABLE border='1' cellpadding='5' cellspacing='0'>"

While rs.EOF <> True
   objResponse.Write "<TR><TD>"
   objResponse.Write rs("name") & "</TD><TD>" & rs("filename")
   objResponse.Write "</TD></TR>"
   rs.MoveNext
Wend

objResponse.Write "</TABLE>"

End Sub

Function showPagesWithParms(ByVal varType As String) As String

Dim cmndObject As New Command
Dim parm As Parameter
Dim rs As Recordset

' set command properties
cmndObject.ActiveConnection = "Provider=SQLOLEDB;server=FLAME;" & _
                              "database=weaver;" & _
                              "uid=sa;pwd="
cmndObject.CommandType = adCmdStoredProc
cmndObject.CommandText = "sp_getpages"
                         
'set parameters
cmndObject.Parameters.Append cmndObject.CreateParameter("return", _
                                              adInteger, adParamReturnValue)
                                              
cmndObject.Parameters.Append cmndObject.CreateParameter("output", _
                                              adInteger, adParamOutput)

Set parm = cmndObject.CreateParameter("page_type_code", adChar, adParamInput, 3)
cmndObject.Parameters.Append parm
parm.Value = varType
                                              
' execute stored procedure
' process results
Set rs = cmndObject.Execute
showPageInfo rs, varType
rs.Close

' get return value
Dim lReturn, lRows As Long
Dim strReturn As String
lReturn = cmndObject(0)
lRows = cmndObject(1)

' create return string
If lReturn > 0 Then
   strReturn = "No rows were found for the page type code"
Else
   strReturn = "Number of rows found was " & CStr(lRows)
End If

Set cmndObject = Nothing

showPagesWithParms = strReturn

End Function
