VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "devaspcompxml"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Function processXMLQuery(ByVal strFile As String) _
                                           As Recordset
                                           
Dim strSelect, strFrom, strWhere, strSQL As String
Dim i As Integer
Dim iCt As Integer

' XML objects
Dim MSXML As New DOMDocument
Dim mslist As IXMLDOMNodeList

' ADO
Dim rs As New Recordset

' load XML file
MSXML.Load (strFile)

' get select fields
Set mslist = MSXML.getElementsByTagName("fieldname")
strSelect = ""
iCt = mslist.length
For i = 0 To iCt - 1
   If strSelect <> "" Then
      strSelect = strSelect & ", "
   Else
      strSelect = "select "
   End If
   strSelect = strSelect & mslist(i).Text
Next

' get tables
Set mslist = MSXML.getElementsByTagName("tablename")
strFrom = ""
iCt = mslist.length
For i = 0 To iCt - 1
   If strFrom <> "" Then
      strFrom = strFrom & ", "
   Else
      strFrom = " from "
   End If
   strFrom = strFrom & mslist(i).Text
Next


' get where clause
Set mslist = MSXML.getElementsByTagName("where")

Dim strField, strValue As String
strWhere = ""
iCt = mslist.length
For i = 0 To iCt - 1
   If strWhere <> "" Then
      strWhere = strWhere & " AND "
   Else
      strWhere = " where "
   End If
   strField = mslist.Item(i).selectSingleNode("queryfield").Text
   strValue = mslist.Item(i).selectSingleNode("queryvalue").Text
   
   strWhere = strWhere & strField & "=" & strValue
Next

' perform query
strSQL = strSelect & strFrom & strWhere
rs.CursorLocation = adUseClient
rs.Open strSQL, "Provider=SQLOLEDB;server=FLAME;database=weaver;uid=sa;pwd="

' disconnect recordset
Set rs.ActiveConnection = Nothing

Set processXMLQuery = rs

End Function


' add field
Sub addXML(ByVal strFileName As String, _
           ByVal strFieldName As String)

' XML objects
Dim MSXML As New DOMDocument
Dim mselement As IXMLDOMNode
Dim msnode As IXMLDOMNode
Dim currnode As IXMLDOMNode
Dim mslist As IXMLDOMNodeList

' load XML file
MSXML.Load (strFileName)

' get fields element
Set mslist = MSXML.getElementsByTagName("fields")
Set mselement = mslist.Item(0)
    
' create node, assign node text
' insert into end of fieldname list
Set msnode = MSXML.createNode(NODE_ELEMENT, "fieldname", "")
msnode.Text = strFieldName
Set currnode = mselement.insertBefore(msnode, Null)

' save xml file
MSXML.save (strFileName)

End Sub

' save to XML document
Sub saveXMLToDocument(ByVal strQuery As String, _
                      ByVal strFile As String)

Dim MSXML As New DOMDocument
Dim rs As New Recordset

' perform query
rs.CursorLocation = adUseClient
rs.Open strQuery, "Provider=SQLOLEDB;server=FLAME;database=weaver;uid=sa;pwd="

' disconnect recordset
Set rs.ActiveConnection = Nothing

' save RS to DOM tree
rs.save MSXML, adPersistXML

' save msxml
MSXML.save strFile

End Sub




' save XML to file
Sub saveXMLToFile(ByVal strQuery As String, _
                      ByVal strFile As String)
Dim rs As New Recordset

' perform query
rs.CursorLocation = adUseClient
rs.Open strQuery, "Provider=SQLOLEDB;server=FLAME;database=weaver;uid=sa;pwd="

' disconnect recordset
Set rs.ActiveConnection = Nothing

' save RS in XML format to file
rs.save strFile, adPersistXML

End Sub





' save XML directly to response (stream)
Sub saveXMLToResponse(ByVal strQuery As String)

Dim objContext As ObjectContext
Dim objResponse As Response

Set objContext = GetObjectContext()
Set objResponse = objContext("Response")

Dim rs As New Recordset

' perform query
rs.CursorLocation = adUseClient
rs.Open strQuery, "Provider=SQLOLEDB;server=FLAME;database=weaver;uid=sa;pwd="

' disconnect recordset
Set rs.ActiveConnection = Nothing

' save RS to DOM tree
objResponse.Write "<?xml version='1.0'?>" & vbCrLf
rs.save objResponse, adPersistXML

End Sub
